rw.ex2.2<-function(prop.sd=0.3, iter=1000, theta0=0){

y<-399; N<-845
Iterations<-iter
mu.theta<-0; s.theta<-100 
prop.s<-prop.sd
theta<-numeric(Iterations) 
current.theta<-theta0 
acc.prob<-0
for (t in 1:Iterations){  
prop.theta<-rnorm( 1, current.theta, prop.s )  
  loga <- ( (prop.theta    * y - N*log(1+exp(prop.theta)   ))
           -(current.theta * y  -N*log(1+exp(current.theta))) 
           +dnorm( prop.theta, mu.theta, s.theta, log=TRUE )
           -dnorm( current.theta, mu.theta, s.theta , log=TRUE ) )
 u<-runif(1)  
 u<-log(u)  
 if( u < loga ) {
      current.theta<-prop.theta	 
      acc.prob <- acc.prob + 1
      }
 theta[t]<-current.theta  
 print(c(theta[t], prop.theta))
}

print(acc.prob/Iterations)
return(theta)

}
# ------------------------------------------------------------------------------------------
# generating samples for different c
#
#
theta1<-rw.ex2.2( prop.sd=0.1, iter=2500, theta0=0 )
theta2<-rw.ex2.2( prop.sd=0.2, iter=2500, theta0=0 )
theta3<-rw.ex2.2( prop.sd=0.35, iter=2500, theta0=0 )
theta4<-rw.ex2.2( prop.sd=0.85, iter=2500, theta0=0 )
#
# generating samples for different starting points
#
#
theta21<-rw.ex2.2( prop.sd=0.35, iter=2500, theta0=-3 )
theta22<-rw.ex2.2( prop.sd=0.35, iter=2500, theta0=-1.5 )
theta23<-rw.ex2.2( prop.sd=0.35, iter=2500, theta0=-0 )
theta24<-rw.ex2.2( prop.sd=0.35, iter=2500, theta0=-1 )
theta25<-rw.ex2.2( prop.sd=0.35, iter=2500, theta0=5 )


erg.mean<-function(x){
	n<-length(x)
	ergmean<-cumsum(x)/cumsum(rep(1,n))
	return(ergmean)
}


# -----------------------------------------------------------------
# behaviour depending on c - initial value=0
#
# 

postscript('chap1_ex06_1.ps', width = 10.0, height = 12.0, horizontal=FALSE)
par(mfcol=c(4,3), xaxs='r', yaxs='r', bty='l' , cex=0.8)

burnin<-500
totiter<-2500
index<-1:totiter

ylims <- range( c(theta1,theta2,theta3,theta4) )

plot( index, theta1, type='l', ylim=ylims, ylab='log-odds', xlab='Iterations', main='Trace plot (c=0.1)' )
plot( index, theta2, type='l', ylim=ylims, ylab='log-odds', xlab='Iterations', main='Trace plot (c=0.2)' )
plot( index, theta3, type='l', ylim=ylims, ylab='log-odds', xlab='Iterations', main='Trace plot (c=0.35)' )
plot( index, theta4, type='l', ylim=ylims, ylab='log-odds', xlab='Iterations', main='Trace plot (c=0.85)' )


#ylims <- range( c(erg.mean(theta1),erg.mean(theta2),erg.mean(theta3),erg.mean(theta4)) )

index2<-burnin:totiter

plot( index, erg.mean(theta1), type='l', ylim=ylims , ylab='log-odds', xlab='Iterations', main='Ergodic Mean plot (c=0.1)' )
lines( index2, erg.mean(theta1[index2]), col=2, lty=2 )
plot( index, erg.mean(theta2), type='l', ylim=ylims , ylab='log-odds', xlab='Iterations', main='Ergodic Mean plot (c=0.2)' )
lines( index2, erg.mean(theta2[index2]), col=2, lty=2 )
plot( index, erg.mean(theta3), type='l', ylim=ylims , ylab='log-odds', xlab='Iterations', main='Ergodic Mean plot (c=0.35)' )
lines( index2, erg.mean(theta3[index2]), col=2, lty=2 )
plot( index, erg.mean(theta4), type='l', ylim=ylims , ylab='log-odds', xlab='Iterations', main='Ergodic Mean plot (c=0.85)' )
lines( index2, erg.mean(theta4[index2]), col=2, lty=2 )

acf( theta1, main='Autocorrelation plot (c=0.1)' )
acf( theta2, main='Autocorrelation plot (c=0.2)' )
acf( theta3, main='Autocorrelation plot (c=0.35)' )
acf( theta4, main='Autocorrelation plot (c=0.85)' )


graphics.off()


# -----------------------------------------------------------------
# behaviour depending on starting point
#
# 
postscript('chap1_ex06_2.ps', width = 10.0, height = 12.0, horizontal=FALSE)
par(mfcol=c(5,2), xaxs='r', yaxs='r', bty='l' , cex=0.8)

burnin<-500
totiter<-2500
index<-1:totiter

ylims <- range( c(theta21,theta22,theta23,theta24,theta25) )

plot( index, theta21, type='l', ylab='log-odds', xlab='Iterations', main='Trace plot (St.value=-3)' )
plot( index, theta22, type='l', ylab='log-odds', xlab='Iterations', main='Trace plot (St.value=-1.5)' )
plot( index, theta23, type='l', ylab='log-odds', xlab='Iterations', main='Trace plot (St.value=0)' )
plot( index, theta24, type='l', ylab='log-odds', xlab='Iterations', main='Trace plot (St.value=1)' )
plot( index, theta25, type='l', ylab='log-odds', xlab='Iterations', main='Trace plot (St.value=5)' )

plot( index2, theta21[index2], type='l', ylab='log-odds', xlab='Iterations', main='Trace plot (St.value=-3)' )
plot( index2, theta22[index2], type='l', ylab='log-odds', xlab='Iterations', main='Trace plot (St.value=-1.5)' )
plot( index2, theta23[index2], type='l', ylab='log-odds', xlab='Iterations', main='Trace plot (St.value=0)' )
plot( index2, theta24[index2], type='l', ylab='log-odds', xlab='Iterations', main='Trace plot (St.value=1)' )
plot( index2, theta25[index2], type='l', ylab='log-odds', xlab='Iterations', main='Trace plot (St.value=5)' )
graphics.off()

ylims <- range( c(erg.mean(theta21),erg.mean(theta22),erg.mean(theta23),erg.mean(theta24),erg.mean(theta25)) )

postscript('chap1_ex06_3.ps', width = 10.0, height = 6.0, horizontal=FALSE)
par(mfcol=c(1,2), xaxs='r', yaxs='r', bty='l' , cex=0.8)
plot( index, erg.mean(theta21[index]), type='l', ylim=ylims, xlab='Iterations', ylab='log-odds', main='Ergodic Mean Plots (all iterations)')
lines( index, erg.mean(theta22[index]), col=2,lty=2)
lines( index, erg.mean(theta23[index]), col=3,lty=3)
lines( index, erg.mean(theta24[index]), col=4,lty=4)
lines( index, erg.mean(theta25[index]), col=5,lty=5)

plot( index2, erg.mean(theta21[index2]), type='l', ylim=c(-0.5,0.5) , xlab='Iterations', ylab='log-odds', main='Ergodic Means (iterations 501-2500)')
lines( index2, erg.mean(theta22[index2]), col=2, lty=2 )
lines( index2, erg.mean(theta23[index2]), col=3, lty=3 )
lines( index2, erg.mean(theta24[index2]), col=4, lty=4 )
lines( index2, erg.mean(theta25[index2]), col=5, lty=5 )
graphics.off()

